---
slug: /en/operations/system-tables/contributors
---
# contributors

Contains information about contributors. The order is random at query execution time.

Columns:

-   `name` (String) — Contributor (author) name from git log.

**Example**

``` sql
SELECT * FROM system.contributors LIMIT 10
```

``` text
┌─name─────────────┐
│ Olga Khvostikova │
│ Max Vetrov       │
│ LiuYangkuan      │
│ svladykin        │
│ zamulla          │
│ Šimon Podlipský  │
│ BayoNet          │
│ Ilya Khomutov    │
│ Amy Krishnevsky  │
│ Loud_Scream      │
└──────────────────┘
```

To find out yourself in the table, use a query:

``` sql
SELECT * FROM system.contributors WHERE name = 'Olga Khvostikova'
```

``` text
┌─name─────────────┐
│ Olga Khvostikova │
└──────────────────┘
```
[Original article](https://clickhouse.com/docs/en/operations/system-tables/contributors) <!--hide-->
